Index: /main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl	(revision 32456)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/gslib.xsl	(revision 32457)
@@ -18,5 +18,6 @@
   <xsl:include href="xml-to-string.xsl"/>
 	
-  <!-- some global parameters - these are set by whoever is invoking the transformation -->
+  <!-- some global parameters - these are set by whoever is invoking the transformation
+  Any servlet init parameters can be accessed by adding a param here-->
   <xsl:param name="interface_name"/>
   <xsl:param name="library_name"/>
@@ -24,4 +25,5 @@
   <xsl:param name="use_client_side_xslt"/>
   <xsl:param name="filepath"/>
+  <xsl:param name="google_tracking_id"/>
   <!-- every pages ....................................................................... -->
 
@@ -382,4 +384,14 @@
 		</div>
     </xsl:for-each>
+  </xsl:template>
+
+  <xsl:template name="aboutGreenstoneLink">
+
+    <div class="paramLabel">
+      <a href="{$library_name}?a=p&amp;sa=gsdl"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.title')"/></a>
+  </div>
+  <div class="paramValue">
+    <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.brief')"/>
+  </div>
   </xsl:template>
 
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/gsdl.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/gsdl.xsl	(revision 32457)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/gsdl.xsl	(revision 32457)
@@ -0,0 +1,67 @@
+<?xml version="1.0" encoding="utf-8"?>
+<xsl:stylesheet version="1.0"
+		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
+		xmlns:java="http://xml.apache.org/xslt/java"
+		xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
+		xmlns:gslib="http://www.greenstone.org/skinning"
+		extension-element-prefixes="java util"
+		exclude-result-prefixes="java util xsl gslib">
+
+  
+  <!-- use the 'main' layout -->
+  <xsl:include href="layouts/main.xsl"/>
+
+  <!-- set page title -->
+  <xsl:template name="pageTitle"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.title')"/></xsl:template>
+
+  <!-- set page breadcrumbs -->
+  <xsl:template name="breadcrumbs">
+    <gslib:siteLink/>
+  </xsl:template>
+
+  <!-- the page content -->
+  <xsl:template match="/page/pageResponse">
+    <xsl:variable name="gsorg_link"><a href="//www.greenstone.org">www.greenstone.org</a></xsl:variable>
+    <p><xsl:value-of select="util:getInterfaceTextWithDOM($interface_name, /page/@lang, 'gsdl.main', $gsorg_link)"  disable-output-escaping="yes"/>
+</p>
+    <dl>
+      <dt><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.technical')"/></dt><dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.technical_desc', '//www.greenstone.org/factsheet')"  disable-output-escaping="yes"/></dd>
+      <dt><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.customisation')"/></dt><dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.customisation_desc', '//wiki.greenstone.org/doku.php?id=en:beginner:customization')"  disable-output-escaping="yes"/></dd>
+      <dt><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.documentation')"/></dt><dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.documentation_desc', '//wiki.greenstone.org;//wiki.greenstone.org/doku.php?id=en:tutorials')"  disable-output-escaping="yes"/></dd>
+      <dt><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.support')"/></dt><dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.support_desc', '//www.greenstone.org/support')"  disable-output-escaping="yes"/></dd>
+      <dt><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.bugs')"/></dt><dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.bugs_desc', 'mailto:greenstone-users@list.waikato.ac.nz')"  disable-output-escaping="yes"/></dd>
+    </dl>
+    <hr/>
+
+    <h3>Kia papapounamu te moana</h3>
+    <p>
+      <br/>kia hora te marino,
+      <br/>kia tere te karohirohi,
+      <br/>kia papapounamu te moana
+      <br/>
+      <br/>may peace and calmness surround you,
+      <br/>may you reside in the warmth of a summer's haze,
+      <br/>may the ocean of your travels be as smooth as the polished greenstone.
+    </p>
+    <p>
+      <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.greenstone_stone')"/>	      
+    </p>
+    <hr/>
+    <h3>Toki Pou Hinengaro</h3>
+    <a href="interfaces/default/images/toki.png" title="view larger toki image"><img style="float:right;" src="interfaces/default/images/toki_sm.png"/></a>
+    <br/>
+    <p><i>'The adze that shapes the excellence of thought'</i></p>
+    <p><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.toki_about1', '//nzdl.org/niupepa')" disable-output-escaping="yes"/></p>
+    <p><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl.toki_about2')"/></p>
+    <p><i>Haramai te toki, haumi e, hui e, tÄiki e!</i></p>
+    </xsl:template>
+
+    
+
+    <xsl:template match="/page/xsltparams">
+      <!-- suppress xsltparam block in page -->
+    </xsl:template>
+
+  </xsl:stylesheet>
+
+
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/home.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/home.xsl	(revision 32456)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/home.xsl	(revision 32457)
@@ -61,7 +61,8 @@
 			<!--<gslib:libraryInterfaceLink/><br/><br/>-->
 			<gslib:authenticationLink/><br/><br/>
-			<gslib:registerLink/><br/>
+			<gslib:registerLink/><br/><br/>
 		</xsl:for-each>
 
+		<gslib:aboutGreenstoneLink/><br/>
 	</xsl:template>
 