Index: main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties
===================================================================
--- main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 32468)
+++ main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 32469)
@@ -178,5 +178,8 @@
 #  Document Editing #
 #####################
-
+de.error=Editing unavailable...
+de.error.unavailable=Document editing is unavailable at this time. Maybe the archives folder is not present.
+de.error.wrong_group=You are not a member of the right group to have edit permission for this collection. 
+de.error.contact_admin=Please contact your library administrator ({0}).
 de.rebuilding_collection=rebuilding collection
 de.no_changes=No changes detected
@@ -286,4 +289,23 @@
 berry.send_fail=Sending mail failed
 
-
-
+##################################
+# About Greenstone page
+##################################
+
+gsdl.title=About Greenstone
+gsdl.brief=About the Greenstone software
+gsdl.main=Greenstone is a suite of software which has the ability to serve digital library collections and build new collections. It provides a versatile way of organizing information and publishing it on the web or on removable media such as DVD or USB thumb drive. Greenstone is produced by the New Zealand Digital Library Project at the University of Waikato, and distributed in cooperation with UNESCO and the Human Info NGO. It is open-source software, available from {0-link} under the terms of the GNU General Public License. 
+gsdl.technical=Technical
+gsdl.technical_desc=See the <a href="{0}">greenstone factsheet</a> for technical details such as versions, platform support and interoperability. There are two major versions of the software: the original Greenstone 2, and Greenstone 3 which is a complete redesign and reimplementation. Greenstone 3 is under active development, and is recommended for download. This page is part of a Greenstone 3 installation. 
+gsdl.customisation=Customisation
+gsdl.customisation_desc=Greenstone is specifically designed to be highly extensible and customisable. New document and metadata formats are accommodated by writing "plugins" (in Perl). Analogously, new metadata browsing structures can be implemented by writing "classifiers." The user interface look-and-feel can be altered using XSLT templates, CSS and Javascript. The source code, in Java, C++, Perl and C++, is available and accessible for modification. For more information, see the <a href="{0}">Greenstone wiki</a>.
+gsdl.documentation=Documentation
+gsdl.documentation_desc=Extensive documentation for the Greenstone software is available on the <a href="{0}">Greenstone Wiki</a>, including step-by-step <a href="{1}">tutorials</a>.
+gsdl.support=Support
+gsdl.support_desc=See the <a href="{0}">support</a> page for details about language specific mailing lists, regional support groups and other resources. 
+gsdl.bugs=Bugs
+gsdl.bugs_desc=We want to ensure that this software works well for you. Please report any bugs to the <a href="{0}">Greenstone Users Mailing List</a>. 
+gsdl.greenstone_stone=Greenstone is a semi-precious stone that (like this software) is sourced in New Zealand. In traditional Maori society it was the most highly prized and sought after of all substances. It can absorb and hold wairua, which is a spirit or life force, and is endowed with traditional virtues that make it an appropriate emblem for a public-domain digital library project. Its lustre shows charity; its translucence, honesty; its toughness, courage; and the sharp edge it can take, justice.
+gsdl.toki_about1=In November 2000, a toki pou tangata (greenstone adze) was presented to the New Zealand Digital Library by MÄori, to acknowledge the important work being done on taonga (treasure) such as the <a href="{0}">Niupepa Collection</a>. The toki was carved by Bernard Makoare of NgÄti WhÄtua and Te Rarawa descent. 
+gsdl.toki_about2=The toki is to symbolize the significance of pounamu (greenstone). It is to inspire the work that is being done here with qualities of mana, authority and leadership. It is a tough stone, a connection to be made. It is to be used to carve out and guide the excellence of thought that is harvested in the New Zealand Digital Library. 
+